"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _cropperjs = _interopRequireDefault(require("cropperjs"));

require("cropperjs/dist/cropper.css");

require("../static/css/simple-react-cropper.css");

var _dummy = _interopRequireDefault(require("../static/img/dummy.png"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SimpleReactCropper =
/*#__PURE__*/
function (_React$Component) {
  _inherits(SimpleReactCropper, _React$Component);

  function SimpleReactCropper() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, SimpleReactCropper);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(SimpleReactCropper)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      src: _dummy.default
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_initCropper", function () {
      _this.cropper = new _cropperjs.default(_this.img, {
        aspectRatio: _this.props.aspectRatio
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_uploadToServer", function () {
      _this.cropper.getCroppedCanvas({
        width: _this.props.width || 500,
        height: _this.props.height || 500,
        minWidth: 0,
        minHeight: 0,
        maxWidth: 1024,
        maxHeight: 1024,
        fillColor: "#fff",
        imageSmoothingEnabled: true,
        imageSmoothingQuality: "high"
      }).toBlob(function (blob) {
        _this.props.upload(blob);
      });

      if (_this.props.closeModal) _this.props.closeModal();
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_handleFileChange", function (e) {
      _this._initCropper();

      var _e$target = e.target,
          validity = _e$target.validity,
          _e$target$files = _slicedToArray(_e$target.files, 1),
          file = _e$target$files[0];

      if (validity.valid) {
        var reader = new FileReader();

        reader.onload = function () {
          _this.setState({
            src: reader.result
          });

          _this.cropper.reset().clear().replace(reader.result);
        };

        reader.readAsDataURL(file);
      }
    });

    return _this;
  }

  _createClass(SimpleReactCropper, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react.default.createElement("div", null, _react.default.createElement("div", {
        style: this.props.containerStyle
      }, _react.default.createElement("img", {
        ref: function ref(node) {
          return _this2.img = node;
        },
        src: this.state.src,
        style: {
          maxWidth: "100%"
        }
      })), _react.default.createElement("div", {
        style: {
          display: "flex",
          justifyContent: "space-between",
          marginTop: "1rem"
        }
      }, _react.default.createElement("input", {
        type: "file",
        id: "origin-image",
        name: "origin-image",
        className: "input-file",
        onChange: this._handleFileChange
      }), _react.default.createElement("label", {
        htmlFor: "origin-image"
      }, "Choose a file"), _react.default.createElement("button", {
        className: "button-save",
        onClick: this._uploadToServer
      }, "Save")));
    }
  }]);

  return SimpleReactCropper;
}(_react.default.Component);

var _default = SimpleReactCropper;
exports.default = _default;